--
-- JiggleSprite
--

-- this actorList class will jiggle the passed sprite.


property mySprite
property myLoc
property myRange
property myDelay
property lastUpdate
property ancestor


on new me, whatSprite
  set mySprite = whatSprite
  puppetSprite mySprite, TRUE
  
  set myLoc = the loc of sprite mySprite
  set myRange = 6
  set myDelay = 10
  
  set ancestor = 0
  
  return me
end

on stepFrame me
  set deltaH = 0
  set deltaV = 0
  
  if voidP(lastUpdate) then 
    set lastUpdate = the timer
  end if
  
  if the timer > (lastUpdate + myDelay) then
    if random(20) > 10 then
      
      -- roll the dice to see which component we change  
      if random(10) < 5 then
        set deltaH = random(myRange)
      end if
      
      if random(10) < 5 then
        set deltaV = random(myRange)
      end if
      
    else
      -- roll the dice to see which component we change  
      if random(10) > 5 then
        set deltaH = -(random(myRange))
      end if
      
      if random(10) > 5 then
        set deltaV = -(random(myRange))
      end if  
    end if
    
    set the locV of sprite mySprite = the locV of myLoc + deltaV
    set the locH of sprite mySprite = the locH of myLoc + deltaH
    updateStage
    
    set lastUpdate = the timer
  end if
end

on destruct me
  puppetSprite mySprite, FALSE
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end
