--
-- NavStructSetUp
--

-- constants:


property ancestor


on new me
  set ancestor = new (script "NavStructMgr")
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on setUp me
  set mainStructure = getDirContents (me, the pathname)
  set modulePath = the pathname & "modules"
  set mod1 = getDirContents (me, modulePath)
  set modules = [:]
  
  repeat with f in mod1
    if f <> "" then
      set tmp = getActivityPath (me, modulePath & pathChar (me) & f)
      if count (tmp) then addProp (modules, f, tmp)
    end if
  end repeat
  
  debug (modules)
  
  --JCODE
  sort modules
  modules = SortActivities(modules)
  --END JCODE
  
  setStruct (me, modules)
end


--JCODE

on SortActivities sortList
  put [] into theActivities
  put count(sortList) into n
  repeat with i = 1 to n
    
    set theActivities = getAt(sortList, i)
    sort theActivities
    setAt(sortList, i, theActivities)
    
  end repeat
  
  return sortList
  
end
--JCODE


-- return the name of the first alphaNumeric director movie contained in the top level of the activityDir.
-- do not add an activity to the list if it does not contain a director movie.

on getActivityPath me, activityPath
  set lst = getDirContents (me, activityPath)  
  set lst2 = []
  repeat with dir in lst
    set tmp = getDirContents (me, activityPath & pathChar (me) & dir)
    sort tmp
    repeat with f in tmp
      if f contains ".dir" or f contains ".dxr" then
        add (lst2, dir & pathChar (me) & f)
        exit repeat
      end if
    end repeat
  end repeat
  return lst2
end
