--
-- Dialog
--

property ancestor

property dialogWindow

on new me
  -- set constants:
  
  -- initialize the ancestor:
  set ancestor = new (script "HelpMIAW")
  
  -- do other initializations:
  initDialogWin (me, the pathname)
  
  return me
end


on destruct me
  
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on initDialogWin me, thePath
  -- this will need the path to the dialog window file
  -- for now
  
  if not thePath then set thePath = the pathname
  
  set dialogWindow = window "dialog"
  set the fileName of dialogWindow = thePath & "dialog"
  set the modal of dialogWindow = 1
  set the windowType of dialogWindow = 3
  
  moveToBack dialogWindow
  
  put "I have init'ed the window..."
end


on openDialogWin me, whatFrame
  if the windowList <> [] then
    -- tell the stage to pause
    sound stop 1
    --sound stop 2
    --puppetSound 0
    updateStage
    set the rect of dialogWindow = centerWindowOnStage (me, the rect of dialogWindow)
    tell dialogWindow
      go to frame whatFrame
    end tell
    open dialogWindow
    updateStage
  else
    alert "The dialog window is not initialized..."
  end if  
end


on closeDialogWin me
  if the windowList <> [] then
    set the rect of dialogWindow = throwWindowWayOffStage (me, the rect of dialogWindow)
    tell the stage 
      updateStage
    end tell
    tell dialogWindow
      sound stop 1
      puppetSound 0
      --sound stop 2
      go to frame "pause"
    end tell
    close dialogWindow
    tell the stage to go to the frame
  else
    alert "The dialog window is not initialized..."
  end if
end


on throwWindowWayOffStage me, theRect
  set newRect = rect(0,0,0,0)
  
  -- we are going to start with the MIAWS way off the stage
  set newRect = rect(0,0,0,0)
  
  set stageRect = rect(the stageLeft, the stageTop, the stageRight, the stageBottom)
  set stageWidth = the right of stageRect - the left of stageRect
  set stageHeight = the bottom of stageRect - the top of stageRect
  
  -- take the passed rect, and figure out the offsets
  set theWidth = the right of theRect - the left of theRect
  set theHeight = the bottom of theRect - the top of theRect
  
  set offsetH = ((stageWidth - theWidth)/2)
  set offsetV = ((stageHeight - theHeight)/2)
  
  set the left of newRect = the left of stageRect + offsetH
  set the top of newRect = the top of stageRect + offsetV
  set the right of newRect = the left of newRect + theWidth
  set the bottom of newRect = the top of newRect + theHeight
  -- the window is now centered
  
  -- now we will push the window all the way up off the top by about 10000 pixels
  -- just to be safe
  set the top of newRect = the top of newRect - 10000
  set the bottom of newRect = the bottom of newRect -10000
  
  return newRect
end


on centerWindowOnStage me, theRect
  set newRect = rect(0,0,0,0)
  
  set stageRect = rect(the stageLeft, the stageTop, the stageRight, the stageBottom)
  set stageWidth = the right of stageRect - the left of stageRect
  set stageHeight = the bottom of stageRect - the top of stageRect
  
  -- take the passed rect, and figure out the offsets
  set theWidth = the right of theRect - the left of theRect
  set theHeight = the bottom of theRect - the top of theRect
  
  set offsetH = ((stageWidth - theWidth)/2)
  set offsetV = ((stageHeight - theHeight)/2)
  
  set the left of newRect = the left of stageRect + offsetH
  set the top of newRect = the top of stageRect + offsetV
  set the right of newRect = the left of newRect + theWidth
  set the bottom of newRect = the top of newRect + theHeight
  
  return newRect
end
