--
-- HelpMIAW
--

property ancestor

property helpWindow
property thePath


on new me
  -- set constants:
  set thePath = the pathName
  
  -- initialize the ancestor:
  set ancestor = new (script "Print")
  
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on initHelpWin me, thePath, theFile
  -- this will need the path to the help window file
  -- for now
  sound stop 1
  --sound stop 2
  unloadCast (me)
  
  if not thePath then set thePath = the pathname
  if not stringP (theFile) then return
  
  if not thePath then set thePath = the pathname
  set helpWindow = window theFile
  set the fileName of helpWindow = thePath & theFile
  -- set the modal of helpWindow = 1
  set the windowType of helpWindow = 3
  set the modal of helpWindow = 1
  set the rect of helpWindow = centerWindowOnStage (me, the rect of helpWindow)
  put "I have init'ed the help window..."
  tell the stage to pause
  open helpWindow
end


on closeHelpWin me
  if the windowList <> [] then
    tell helpWindow to pause
    
    set the rect of helpWindow = throwWindowWayOffStage (me, the rect of helpWindow)
    tell the stage 
      updateStage
    end tell
    
    close helpWindow
    forget helpWindow
    updateStage
    --puppetSound 0
    unloadCast (me)
    tell the stage
      go to the frame
    end tell
    -- tell the stage to go to the Frame
    put "forgot helpWindow..."
  else
    alert "The help window is not initialized..."
  end if
end


on throwWindowWayOffStage me, theRect
  set newRect = rect(0,0,0,0)
  
  -- we are going to start with the MIAWS way off the stage
  set newRect = rect(0,0,0,0)
  
  set stageRect = rect(the stageLeft, the stageTop, the stageRight, the stageBottom)
  set stageWidth = the right of stageRect - the left of stageRect
  set stageHeight = the bottom of stageRect - the top of stageRect
  
  -- take the passed rect, and figure out the offsets
  set theWidth = the right of theRect - the left of theRect
  set theHeight = the bottom of theRect - the top of theRect
  
  set offsetH = ((stageWidth - theWidth)/2)
  set offsetV = ((stageHeight - theHeight)/2)
  
  set the left of newRect = the left of stageRect + offsetH
  set the top of newRect = the top of stageRect + offsetV
  set the right of newRect = the left of newRect + theWidth
  set the bottom of newRect = the top of newRect + theHeight
  -- the window is now centered
  
  -- now we will push the window all the way up off the top by about 10000 pixels
  -- just to be safe
  set the top of newRect = the top of newRect - 10000
  set the bottom of newRect = the bottom of newRect -10000
  
  return newRect
end


on centerWindowOnStage me, theRect
  set newRect = rect(0,0,0,0)
  
  set stageRect = rect(the stageLeft, the stageTop, the stageRight, the stageBottom)
  set stageWidth = the right of stageRect - the left of stageRect
  set stageHeight = the bottom of stageRect - the top of stageRect
  
  -- take the passed rect, and figure out the offsets
  set theWidth = the right of theRect - the left of theRect
  set theHeight = the bottom of theRect - the top of theRect
  
  set offsetH = ((stageWidth - theWidth)/2)
  set offsetV = ((stageHeight - theHeight)/2)
  
  set the left of newRect = the left of stageRect + offsetH
  set the top of newRect = the top of stageRect + offsetV
  set the right of newRect = the left of newRect + theWidth
  set the bottom of newRect = the top of newRect + theHeight
  
  return newRect
end
