--
-- Print
--

property ancestor

property printer
property printFont
property printSize
property okFlag
property defRect
property printString  -- a string appended to the bottom of a Nystrom Certificate
property printForground  -- a member (field) set in the foreground of a Nystrom Certificate
property printBackground  -- a member (bmp) set in the background of a Nystrom Certificate

on new me
  -- set constants:
  set defRect = rect(0, 31, 640, 430)
  
  -- initialize the ancestor:
  set ancestor = new (script "ClearEvents")
  
  -- do other initializations:
  if xtraExists(ancestor, "printomatic") then
    set okFlag = TRUE
  else
    set okFlag = FALSE
    alert "printOMatic was not loaded!"
  end if
  
  set printString = ""
  return me
  
end

----

on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end

----

on setPrintString me, str
  set printString = str
end


on setPrintBackground me, name
  set printBackground = name
end


on setPrintForgroundMem me, name
  set printForground = name
end

----

on initPrinter me
  unload
  
  if not(okFlag) then
    put "Printing was not initialized"
    return 0
  end if
  
  set printer = new(xtra "printomatic")
  
  if not objectP (printer) then 
    alert "You printer is not responding.  Please check to see if it is connected properly."
    return 0
  end if
  
  set printFont = "helvetica"
  set printSize = 14
  
  return 1
end

----

on printActivitySpace me, theRect, noTextFlag, klugeFlag
  if voidP (theRect) then set theRect = rect (0, 29, 640, 428)
  
  set doc = xtra("PrintOMatic").new()
  if not objectP(doc) then
    alert "Your printer is not responding. Please check to see if it is connected properly."
    return 0
  end if
  
  doc.register("PMAT170-347-92772")
  
  if the platform contains "win" then
    doc.setTextFont("Arial")
    doc.setProgressMsg("Now Printing" & RETURN & "For faster printing, try turning off the print manager.")
  else
    doc.setTextFont("Helvetica")
    doc.setProgressMsg("Now Printing")
  end if
  doc.setTextJust("centered")
  doc.setTextSize(36)
  doc.setDocumentname("Nystrom Printable Document")
  doc.setLandscapeMode(true)
  
  put "w: " & doc.getPageWidth() & ", H: " & doc.getPageHeight()
  
  --doc.drawPicture(member printBackground, rect(0, 0, doc.getPageWidth(), doc.getPageHeight()))
  
  doc.newPage()
  --set newRect = rect(0, 31, 393, 428)
  doc.newFrame(theRect, false)
  doc.drawStagePicture(theRect)
  
  --doc.append(member "logo", true)
  --set myString = the text of member printForground
  -- put myString
  --doc.append(myString, true)
  
  doc.printStage()
  
  
end

----


on printCertificate me
  set doc = xtra("PrintOMatic").new()
  if not objectP(doc) then
    alert "Your printer is not responding. Please check to see if it is connected properly."
    return 0
  end if
  
  doc.register("PMAT170-347-92772") 
  
  if the platform contains "win" then
    doc.setTextFont("Arial")
    doc.setProgressMsg("Now Printing" & RETURN & "For faster printing, try turning off the print manager.")
  else
    doc.setTextFont("Helvetica")
    doc.setProgressMsg("Now Printing")
  end if
  doc.setTextJust("centered")
  doc.setTextSize(36)
  doc.setDocumentname("Nystrom Printable Document")
  doc.setLandscapeMode(true)
  
  put "w: " & doc.getPageWidth() & ", H: " & doc.getPageHeight()
  
  if voidP(printBackground) then
    set printBackground = "CERT-08"
  end if
  if voidP(printForground) then
    printForground = "certificateName"
  end if
  
  doc.drawPicture(member printBackground, rect(0, 0, doc.getPageWidth(), doc.getPageHeight()))
  
  doc.newPage()
  set newRect = rect(190, 135, 610, 204)
  doc.newFrame(newRect, false)
  --doc.append(member "logo", true)
  set myString = the text of member printForground
  put myString
  doc.append(myString, true)
  
  doc.print()
  
  
end




on drawPictureSub me, whatDoc, mem, locPoint
  
  if count(locPoint) = 2 then 
    set topLeft = locPoint
    set botRight = locPoint + point (the width of mem, the height of mem)
    newFrame (whatDoc, rect(topLeft, botRight), FALSE)
  else
    newFrame(whatDoc, locPoint, FALSE)
  end if
  
  append (whatDoc, mem)
end

