--
-- xTools
--

property ancestor
property xPath
property foundFlag

on new me
  -- set constants:
  
  -- initialize the ancestor:
  set ancestor = new (script "AppTools")
  
  -- we will get the name of the volume we are on, and then build an absolute path to the xtra folder of choice
  
  set targetFolder = "Xtras"
  
  set foundFlag = 0
  
  -- lets start by looking in this folder for the right xPath, then we will walk up to the root,
  -- looking as we go...
  set folderPath = the pathName
  set xPath = findFileUpStream(me, folderPath, targetFolder)
  
  if xPath = 0 then
    alert "xobject folder not found, make sure it is there..."
  else
    set foundFlag = 1
    
    -- now we are going to open the xObject folder
    initXobjFolder(me, xPath)
  end if
  
  return me
end

-- this will open a whole folder full of openXlib-able things
on initXobjFolder me, thePath
  -- now find all the xtras/xobjects in that folder
  set fileList = []
  repeat with x = 1 to the maxInteger
    set n = getNthFileNameInFolder(thePath, x)
    
    if n = EMPTY then 
      exit repeat
    end if
    
    -- just in case we want to store some other crap in that folder
    -- any item with the string "pref" in it will be skipped
    if n contains "pref" then
      next repeat
    end if
    
    
    if pD(me) = "\" then
      if not (n contains ".dll") then 
        next repeat
      end if
    else
      next repeat
      --      if (n contains ".dll" or n contains ".X16" or n contains ".X32") then 
      --        next repeat
      --      end if
    end if
    
    append(fileList, (thePath & n))
  end repeat  
  
  if the optionDown then
    put thePath
  end if
  
  -- put fileList
  
  repeat with x in fileList
    openXlib x
  end repeat
  -- now all the xobjects should be open..  
  
  return 1
end

-- clear out all of my stuff
on destruct me
  -- close all the x things
  -- now find all the xtras/xobjects in that folder
  put [] into fileList
  repeat with x = 1 to the maxInteger
    set n = getNthFileNameInFolder(xPath, x)
    
    if n = EMPTY then 
      exit repeat
    end if
    
    if pD(me) = "\" then
      if not (n contains ".dll") then 
        next repeat
      end if
    else
      next repeat
      --      if (n contains ".dll" or n contains ".X16" or n contains ".X32") then 
      --        next repeat
      --      end if
    end if
    
    
    -- just in case we want to store some other crap in that folder
    -- any item with the string "pref" in it will be skipped
    if n contains "pref" then
      next repeat
    end if
    
    append(fileList, (xPath & n))
  end repeat  
  
  repeat with x in fileList
    -- put x
    closeXlib x
  end repeat
  -- now all the xobjects are closed
  
  -- destruct my chain
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


-- this tells you if an xTra is currently opened or not
-- this will only be useful if the xobjects/xcmds/xfcns/xtras are opened before it is called, otherwise, it will
-- miss them all. (especially xcmds/xfcns).

-- this will also look for word fragments using a "contains", so you could ask it for "printo" and get a return on 
-- printomatic
on xtraExists me, theXtraNameString
  set maxXtras = the number of xtras
  
  -- walk through the xtras list
  repeat with x = 1 to maxXtras
    set thisXtra = the name of xtra x
    
    -- if we hit an exact match then fine, else look for a contains
    if thisXtra = theXtraNameString or thisXtra contains theXtraNameString then
      return 1
    end if
  end repeat
  
  -- now we should look through the available xObjects
  set xObjectList = xFactoryList("")
  
  -- debug
  return 1
  -- debug
  
  if xObjectList contains theXtraNameString then
    return 1
  else
    -- alert theXtraNameString & " : is not opened, please make sure it is in the right place..."
    put theXtraNameString & " : is not opened, please make sure it is in the right place..."
    return 0
  end if
end 