--
-- GraphTool
--

property ancestor

property graphSpriteList


on new me
  -- set constants:
  
  
  -- initialize the ancestor:
  set ancestor = new (script "PictLinkTool")
  
  -- do other initializations:
  set graphSpriteList = 0
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


-- sprList should be a prop list as follows:
-- [name:spriteNum, name:spriteNum]
-- directions are: #up, #down, #left, #right

on makeGraph me, key, spr, increment, direction
  if voidP (key) then 
    put "makeGraph should have: key, sprite & increment as arguments"
    return 
  end if
  
  set tmp = []
  addAt (tmp, 1, spr)
  addAt (tmp, 2, increment)
  
  if voidP (direction) then set direction = #up
  addAt (tmp, 3, direction)
  
  if not listP (graphSpriteList) then set graphSpriteList = [:]
  addProp (graphSpriteList, key, duplicate (tmp))
end


-- move
on moveGraph me, key
  if not listP (graphSpriteList) then return
  
  set lst = getAProp (graphSpriteList, key)
  if not listP (lst) then return
  
  set spr = getAt (lst, 1)
  set increment = getAt (lst, 2)
  set direction = getAt (lst, 3)
  
  puppetSprite spr, TRUE
  
  set sH = the locH of sprite spr
  set sV = the locV of sprite spr
  
  case (direction) of
      
    #left:
      set endH = sH - integer(increment)
      
      repeat while endH < the locH of sprite spr 
        set the locH of sprite  spr = the locH of sprite spr - 1
        updateStage
      end repeat
      
    #right:
      set endH = sH + integer(increment)
      
      repeat while endH > the locH of sprite spr 
        set the locH of sprite  spr = the locH of sprite spr + 1
        updateStage
      end repeat
      
    #down:
      set endV = sV + integer(increment)
      
      repeat while endV > the locV of sprite spr 
        set the locV of sprite  spr = the locV of sprite spr + 1
        updateStage
      end repeat
      
    otherwise
      set endV = sV - integer(increment)
      
      repeat while endV < the locV of sprite spr 
        set the locV of sprite  spr = the locV of sprite spr - 1
        updateStage
      end repeat
      
  end case
  
end
