--
-- AppTools
--
-- a collection of general tools for application building.
-- when a group starts to have a logical abstraction, create a new class!


property ancestor


on new me
  set ancestor = new (script "SimpleAnim")
  return me
end


on destruct me
  killActorList (me)
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on killActorList me
  repeat with x in the actorList
    destruct(x)
    set x = 0
  end repeat
  set the actorList = []
end



-- return a list of non-#empty castMembers in the passed castLibNum:
-- formatted as follows: [#memberName:memberNum, #memberName:memberNum, ... ]

on getAvailableMemberList me, Lib
  if not Lib then return 0
  
  set lst = [:]
  repeat with i = 1 to 60  -- was 1000 but not currently necessary
    if the type of member i of castLib Lib <> #empty then
      addProp (lst, value("#" & the name of member i of castLib Lib), i) -- (do not copy over!)
    end if
  end repeat
  
  return lst
end


-- pass the number of seconds to wait:

on wait me, t
  set t = t * 60
  startTimer
  repeat while the timer < t
    updateStage
  end repeat
end


-- default setUp returns TRUE (=successful)

on setUp me
  return 1
end


-- return the loc of the mouse (a Lingo deficiency!)

on mouseLoc me
  return point (the mouseH, the mouseV)
end



-- make a new castMember and store information in it:
-- make sure that the member does not currently exist:

on makeField me, name, val
  if stringP (name) then 
    set nameString = name
    set name = value ("#" & name)
  else
    set nameString = string (name)
  end if
  
  set tmp = getAvailableMemberList (me, "Internal")
  if not getAProp (tmp, name) then
    set mem = getFirstEmptyMember (me, "Internal")
  else 
    set mem = the memberNum of member nameString
  end if
  
  put val into member mem of castLib "Internal"
  set the name of member mem of castLib "Internal" to nameString
  
end


on getFirstEmptyMember me, lib
  repeat with i = 1 to 1000
    if the type of member i of castLib lib = #empty then return i
  end repeat
  return 0
end


-- get the contents of a folder.
-- return a list of file/subfolder names.

on getDirContents me, path
  set lst = []
  
  set i = 1
  repeat while TRUE
    set f = getNthFileNameinFolder(path, i)
    if f = "" then exit repeat
    add (lst, f)
    set i = i + 1
  end repeat
  
  return lst
end


on pathChar me
  if the machineType = 256 then return "\"
  else return ":"
end