--
-- SpriteTools
--
-- tools for handling sprites:


property ancestor
property snapFlag


on new me
  -- set constants:
  
  -- initialize the ancestor:
  set ancestor = new (script "ListMgmt")
  
  -- do other initializations:
  set snapFlag = TRUE
  
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end



on moveOffScreen me, spr
  puppetSprite spr, TRUE
  if the locv of sprite spr < 10000 then
    set the locv of sprite spr to (the locv of sprite spr) + 10000
  end if
end


on moveOnScreen me, spr
  puppetSprite spr, TRUE
  if the locv of sprite spr > 10000 then
    set the locv of sprite spr to (the locv of sprite spr) - 10000
  end if
end


-- snap the location of sprite spr to the location of sprite target:

on snapToPosition me, spr, target
  if not snapFlag then return
  set the loc of sprite spr to the loc of sprite target
end

on snapOff me
  set snapFlag = false
end



-- return the number of sprites Diretor can use:
-- 5.0 = 48
-- 6.0 = 120

on numSprites me
  --JCODE
  --  global gTotalSprites
  --  return gTotalSprites
  return 120
  --END JCODE
end


on spritesOff me
  repeat with i = 1 to numSprites (me)
    puppetSprite i, FALSE
  end repeat
  unloadCast (me)
end
