--
-- standard paint manager object
--

-- this is tied to the score in the nystrom UI setup

property ancestor
property startingPictFlag

global gPrinterB,gBannerartB,gLeftB,gSpeakerB,gHomeB,gHelpB,gRightB

on new me
  -- initialize constants:
  
  set ancestor = new (script "DrawPalette")
  
  if ancestor = 0 then
    alert "There is something wrong in the initialization of the tools..."
    halt
    return 0
  end if
  
  set startingPictFlag = FALSE
  return me
end



on initStartingPict me, bmpMemberName
  initStartingPict (ancestor, bmpMemberName)
  set startingPictFlag = TRUE
end


-- handle the mousedowns right here
-- like a traffic cop

on mouseDown me, spr  
  -- fire the mouseDown to the subordinate classes
  if spr = gPrinterB and the frameLabel = "play" then
    set mem = the memberNum of sprite spr 
    set cLib = the castLibNum of sprite spr
    if mem then set name = item 1 of the name of member mem of castLib cLib
    else set name = 0
    
    if basicNameAnim (me, name, spr, 6) then print (rect (82,56,550,400), TRUE, FALSE)
    
    return 1
  else if mouseDownTools(me, spr) then
    return 1
  else if mouseDownPalette(me, spr) then
    return 1
  else if the name of member the memberNum of sprite spr of castLib the castLibNum of sprite spr = "resetButton" then
    bounceButton (spr)
    clearCanvas (me)
    return 1
  else if the name of member the memberNum of sprite spr of castLib the castLibNum of sprite spr = "doneButton" then
    bounceButton (spr) 
    directOff (me)
    clearCanvasCursor (me)
    go "finish"
    return 1
  end if
  
  return 0
end


on initializeRound me
  put "I am initializing the paint round..."
  
  -- this will set up the initial paint status based on the first sprite in each of the 2
  -- underlying lists
  
  -- use the first tool
  set spr = getAt(findColoredSprites(me, 2, 1), 1)
  
  if mouseDownTools(me, spr) = 0 then
    alert "tool initialization failed, make sure they are the right color in the score..."
  end if
  
  if not startingPictFlag then clearCanvas (me)
  setCanvasSize (me, 344, 468)
  directOn (me)
  
  -- use the first color
  set spr = getAt(findColoredSprites(me, 3, 1), 1)
  
  if mouseDownPalette(me, spr) = 0 then
    alert "palette initialization failed, make sure they are the right color in the score..."
  end if
end

on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end

