--
-- GridType
--

-- this class handles all runtime game management
-- for a typical C & I Game.
-- for variations, extend this class in the individual activity.

-- constants:
property delaySecs

property ancestor
property currentID
property responseFlag

property locationList
property currName
property currNumber
property currLetter

--JCODE
global gUI

on new me
  -- initialize constants:
  set delaySecs = 1
  
  set ancestor = new (script "ActivityLib")
  
  set responseFlag = TRUE
  -- add (the actorList, new (script "ObjectUpdater", me))
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on initializeRound me
  set locationList = [#airport:"C,3", #highway:"B,3", #lakeview:"A,2", #oceanside:"B,4", #bridge:"B,3", #swamp:"B,5", #island:"D,5", #eastedge:"A,5"]
  
  initPlay (me)
end


----------------------
-- activity modifiers:
----------------------


on noResponse me
  set responseFlag = FALSE
end



--------------------
-- activity process:
--------------------

-- handle a mouseDown for all activity sprites.
-- return 1 if we have hit an activity sprite, return 0 otherwise for further processing:

on mouseDown me, spr
  
  if spr = 3 then 
    set name = the name of member the memberNum of sprite 3 of castLib the castLibNum of sprite 3
    
    if not basicNameAnimSilent (me, name, spr, 1) then return 0
    
    if currLetter = the text of field "letterInput" and currNumber = the text of field "numberInput" then
      
      if responseFlag then playResponseSound(1, 1)
      
      -- play the proper "ID" sound:
      playSprite (gUI, spr, #ID)
      
      -- otherwise check to see if we are done with the activity:
      done (me)
    else
      playResponseSound(0, 1)
      put "" into field "letterInput"
      put "" into field "numberInput"
    end if
    return 1
  else
    return 0
  end if
end


-- check to see if we are done.  
-- if so, then do an action.

on done me
  wait (me, 1)
  clearPictLink (me)
  if count (locationList) then 
    initPlay (me)
    return 0
  else
    wait (me, delaySecs)
    go "finish"
    return 1
  end if
end


-- initialize an individual play:

on initPlay me
  set t = random (count (locationList))
  set currName = string (getPropAt (locationList, t))
  set the itemDelimiter = ","
  set currLetter = item 1 of getAProp (locationList, currName)
  set currNumber = item 2 of getAProp (locationList, currName)
  deleteAt (locationList, t)
  put " " into field "letterInput"
  put " " into field "numberInput"
  
  setUpBanner(gUI, currName)
end



