--
-- GridTypeSetUp
--

-- this class handles the pre-runtime initialization of Match Game data.
-- this class can be discarded before protecting movies for distribution.

property ancestor

-- the following are constants:
property answerCast1  -- the castLib of the answerKeys


on new me
  -- set up all constants first:
  set answerCast1 = the number of castLib "locations"
  
  set ancestor = new (script "GridTypeListMgmt")
  setUp (me) -- automatic setup
  
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


-- do all pre-runtime setup work for the class and return to starting frame:
-- (frame motion disabled for Nystrom set)

on setUp me
  -- set startFrame = the frame
  -- go frame setUpFrame
  
  set memberInfo = gatherMemberInfo (me)
  if not listP (memberInfo) then
    alert "Problem gathering member info."
    return 0
  end if
  
  setList (ancestor, memberInfo)
    
  -- if we have gotten to this point then do an ancestor setUp:
  return setUp (ancestor)
end



-- gather information on members and castLibs to be used in the match game:

on gatherMemberInfo me
  set m1 = getAvailableMemberList (me, answerCast1)
  
  -- add possible animations for these members:
  addAnimations (me, answerCast1, m1)
  
  -- gather the lists of potential members:
  set memList = [:]
  addProp (memList, answerCast1, m1)
  
  return memList
end