--
-- GridTypeListMgmt
--
-- the basic click and identify game
-- 'hidden' in this context refers to sprites that haven't been clicked yet.

property ancestor

property memberList  -- property list of castLibs containing a list of available member nums.

-- the following are all constants:
property appDataMember  -- the member (name) that contains the appList

property currentID  -- the identifier currently being played.
property removeFlag  -- if TRUE then move the clicked item off the screen.

property playLst  -- the temporary list 

--JCODE was missing
property spriteList  -- the appList contains general information needed to run the application.

on new me
  set ancestor = new (script "ActivityLib")
  
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on initializeRound me
  nothing  -- currently
end




on checkDone me
  if not count (playLst) then return 0
  else return 1
end


-- initialize a round of play by choosing a code from the memberList:

on initPlay me
  -- first get the playable list of identifiers.  There can be no repeat identifiers in the pool or that would
  -- upset the even distribution:
  set playList = [:]
  --JCODE
  --set num = count (spriteList)
  set num = spriteList.count
  --END JCODE
  repeat with i = 1 to num
    set spr = getPropAt (spriteList, i)
    if isHidden (me, spr) then
      set id = getID (me, spr)
      setAProp (playList, id, spr)  -- no duplicates will be added and we have easy access to the id.
    end if
  end repeat
  
  
  -- then randomly choose an id:
  set num = random (count (playList))
  if not num then put "There are no more clickable sprites.  The game should be over."
  
  set currentID = getPropAt (playList, num)
  set spr = getAProp (playList, currentID)
  return spr  -- return a sprite number to comply with other games.
end


-- lst = type sprite list.

on getID me, spr
  set lst = getAProp (spriteList, spr)
  return getAProp (lst, #identifier)
end


on isHidden me, spr
  set lst = getAProp (spriteList, spr)
  return not getAProp (lst, #showFlag)
end