--
-- MatchGame
--

-- this class handles all runtime game management
-- for a typical Match Game.
-- for variations, extend this class in the individual activity.

-- constants:
property delaySecs


property ancestor
property card


on new me
  -- initialize constants:
  set delaySecs = 1
  
  set ancestor = new (script "MatchGroupSetUp")
  
  set card = 0
  
  -- add (the actorList, new (script "ObjectUpdater", me))
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on initializeRound me
  initializeRound (ancestor)
  hideAnswerCards (me)
  initHandCursor ("pointer", getMatchPieceList (me))
end


on mouseDown me, spr
  if not showAnswerCard (me, spr) then return 0
  set matchSprite = checkMatch (me, spr)
  
  case (TRUE) of 
    (matchSprite <> 0): -- two cards showing match:
      -- do the corresponding animation for the matched sprites.
      animateSprites (me, [spr, card]) 
      
      -- move a bar graph if one has been set up:
      moveGraph (me, the name of member the memberNum of sprite matchSprite of castLib the castLibNum of sprite matchSprite)
      
      -- reset sprite information:
      set card = 0
      
      done (me)
    (card <> 0):  -- two cards showing don't match:
      wait (me, delaySecs)
      hideAnswerCard (me, spr)
      hideAnswerCard (me, card)
      set card = 0
    otherwise: -- first card is now showing:
      set card = spr
  end case
  
  return 1
end


-- check to see if we are done.  
-- if so, then do an action.

on done me
  if checkDone (ancestor) then 
    playResponseSound(1, 1)
    wait (me, delaySecs)
    go "finish"
    unloadCast (me)
    clearHandCursor
  else
    initHandCursor ("pointer", getMatchPieceList (me))
  end if
end