--
-- SinglePointPusher
--

property ancestor
property currSpr

on new me
  -- set constants:
  
  
  -- initialize the ancestor:
  set ancestor = new (script "DragDropSetup")
  
  -- do other initializations:
  set currSpr = 0
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


-- push all the draggables off screen, whether played or not

on pushOffDraggables me
  set dList = the draggableList of me
  
  set lst = []
  set num = count (dList)
  repeat with i = 1 to num
    add (lst, getPropAt (dList, i))
  end repeat
  
  repeat with spr in lst
    moveOffScreen (me, spr)
  end repeat
end


-- it will push one of the remaining draggables on screen for play.
-- return the sprite of the draggable.

on pushOnDraggable me
  if the randomFlag of me then set currSpr = getRandomDraggable (me)
  else set currSpr = getNextDraggable (me)
  moveOnScreen (me, currSpr)
  return currSpr
end


on getCurrentDraggable me
  return currSpr
end
