--
-- DragMemberMgmt
--

property ancestor

property memberList  -- a list of members

-- the following are all constants:
property appDataMember  -- the member (name) that contains the appList
property useAllDraggables

property draggablesCst, targetsCst  -- the casts of the answerKeys


on new me
  -- set constants:
  set appDataMember = "ActivityPredefines"  -- currently we are using the name of the storage field.
  set useAllDraggables = TRUE
  
  set draggablesCst = the number of castLib "draggables"
  set targetsCst = the number of castLib "baskets"
  
  set ancestor = new (script "ActivityLib")
  
  gatherMemberInfo (me)
  
  return me
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


on useAllDraggables me
  return useAllDraggables
end


-- gather information on members and castLibs to be used in the match game:

on gatherMemberInfo me
  -- get presaved member data if we are in protected mode:
  if the movieName contains ".dxr" or the movieName contains ".exe" then 
    set memberList = value (field appDataMember)
    return
  end if
  
  set draggables = getAvailableMemberList (me, draggablesCst)
  set targets = getAvailableMemberList (me, targetsCst)  -- targets are just here for draggable match checks.
  
  -- check that draggables have corresponding members in targets.
  -- cut out all unusable draggable members:
  if not returnPropMatchList (me, draggables, targets) then
    alert "Not all of the member names of castlib" && draggables && "have matching members in castlib" && targets && "(See the message window for specifics)"
    return 0
  end if
  
  -- add possible animations for these members:
  addAnimations (me, draggablesCst, draggables)
  addAnimations (me, targetsCst, targets)
  
  -- gather the lists of potential draggable members.
  -- (we won't need the list of target members here.)
  set memList = [:]
  addProp (memList, draggablesCst, draggables)
  
  set memberList = memList
  makeField (me, appDataMember, memberList)
end