--
-- Drawing palette tools for the standard paint
--

-- this is tied to the score in the nystrom UI setup

property ancestor
property paletteList
property paletteSprites
property currentColor
property canvasName
property canvasSprite


on new me
  -- initialize constants:
  -- this is the hardcoded Nystrom palette
  set paletteList = [255,0,5,35,237,248,230,226,156,24,224,23,15,250]
  set paletteSprites = []
  
  set currentColor = 255
  
  set ancestor = new (script "DrawTools")
  
  set paletteSprites = findColoredSprites(me, 3, 1)
  
  if paletteSprites = [] then
    alert "The palette sprites are not colored correctly in the score, they should be #3, blue..."
    return 0
  end if
  
  set maxSprites = count(paletteSprites)
  set maxColors = count(paletteList)
  
  repeat with x = 1 to maxSprites
    if x > maxColors then
      exit repeat
    else
      set the foreColor of sprite (getAt(paletteSprites, x)) = 255
      set the backColor of sprite (getAt(paletteSprites, x)) = getAt(paletteList, x)
      updateStage
    end if
  end repeat
  
  -- put "palettes: looking for the canvas..." & findColoredSprites(me, 1, 0)
  
  set canvasName = the name of member (the memberNum of sprite getAt(findColoredSprites(me, 1, 1), 1))
  set canvasSprite = sprite getAt(findColoredSprites(me, 1, 1), 1)
  
  set the connectfreehandlines of member canvasName = 1
  set the optimizedcompositedrawing of member canvasName = 1
  set the optimizedfreehandlines of member canvasName = 1
  set the fillcolorprotection of member canvasName = 1
  set the autoredraw of member canvasName = 1
  set the trapevents of member canvasName = 1
  -- set the preloadcompositebuffer of member canvasName = 1
  
  
  return me
end

-- handle the mousedowns right here
on mouseDownPalette me, spr
  if paletteSprites = [] then return 0
  
  if getPos(paletteSprites, spr) > 0 then
    -- we hit a palette sprite
    
    set currentColor = the backColor of sprite spr
    
    if (getCurrentTool (me) <> "eraser") then setPaletteColor (me, currentColor)
    
    -- now toggle the rest of the colors
    colorRadioToggle(me, paletteSprites, spr, 2)
    
    return 1
  else
    return 0
  end if
end


on mouseDownTools me, spr
  set r = mouseDownTools (ancestor, spr)
  if (getCurrentTool (me) <> "eraser") then setPaletteColor (me, currentColor)
  return r
end


on setPaletteColor me, color  
  -- now convert the index to a packedColor
  set packedColor = IndexedToPackedColor(member canvasname, color)
  
  -- now assign the thing
  SetForecolor(member canvasName, packedColor)
end


on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end


