--
-- score tools
--

-- these handlers can search through the score and do some stuff

property ancestor

on new me
  -- initialize constants:
  set ancestor = new (script "AppTools")
  
  return me
end

-- this scans through the score, and finds the canvas sprite
on findColoredSprites me, whatColor, pMe
  global gTotalSprites
  set sprList = []
  repeat with x = 1 to gTotalSprites
    if the scoreColor of sprite x = whatColor then
      if pMe then
        puppetSprite x, true
      end if
      
      add(sprList, x)
    end if
  end repeat
  
  return sprList
end

-- a little stolen routine that will swap a sprite's member with a given member called downbutton
-- and then return it to the previous member
-- all the code depends on a "," delimited naming convention
on bounceButton me, downButton, spr
  set saveCast   = the castNum of sprite spr
  
  if downButton = FALSE then 
    set downButton = (the name of cast saveCast) & ",down"
  end if
  
  set the castNum of sprite (the clickon) to (the number of cast downButton)
  updateStage
  wait (20)
  
  repeat while the stillDown
    updateStage
  end repeat
  
  set the castNum of sprite spr to saveCast
  updateStage
end

-- a little stolen routine that will swap a sprite's member with a given member called downbutton
-- and leave the button in the down position
-- all the code depends on a "," delimited naming convention
on pushButton me, downButton, spr
  set saveCast = the castNum of sprite spr
  puppetSprite spr, true
  
  if downButton = FALSE then 
    set downButton = (the name of cast saveCast) & ",down"
  end if
  
  set the castNum of sprite spr to (the number of cast downButton)
  updateStage
  
  repeat while the stillDown
    updateStage
  end repeat
end


-- this just unpuppets a bunch of sprites, and then pushes down a given sprite
-- it takes a string that is the additional part of the down name as a param
-- all the code depends on a "," delimited naming convention

on radioToggle me, theList, spr, downAppendStr
  repeat with x in theList
    if x = spr then 
      set myName = item 1 of the name of member (the memberNum of sprite spr)
      set myName = myName & downAppendStr
      pushButton(me, myName, spr)
      next repeat
    end if
    
    puppetSprite x, FALSE
  end repeat  
end


-- this just unpuppets a bunch of sprites, and then pushes down a given sprite
-- it takes a string that is the additional part of the down name as a param
-- all the code depends on a "," delimited naming convention
on colorRadioToggle me, theList, spr, downColor
  repeat with x in theList
    puppetSprite x, TRUE
    
    if x = spr then 
      set the foreColor of sprite spr = downColor
      next repeat
    end if
    
    set the foreColor of sprite x = 255
    updateStage
  end repeat  
end

on destruct me
  if objectP (ancestor) then destruct (ancestor)
  set ancestor = 0
end

